## Script (Python) "livesearchwidget_reply"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=q,allowed_type,fieldName,multi,limit=10,objectId=None
##title=Determine whether to show an id in an edit form
##
from Products.CMFCore.utils import getToolByName

object = None
FACTORY_INFO = context.REQUEST.get('__factory__info__', None)
if FACTORY_INFO:
  # factory info should only have 1 entry.. (except for plone3)
  for k,v in FACTORY_INFO.items():
    try:
      if v.portal_type == 'TempFolder':
        object = v.restrictedTraverse(objectId)
    except:
      # plone3 also returns the stack
      pass

ploneUtils = getToolByName(context, 'plone_utils')
pretty_title_or_id = ploneUtils.pretty_title_or_id

portalProperties = getToolByName(context, 'portal_properties')
siteProperties = getattr(portalProperties, 'site_properties', None)
useViewAction = []
if siteProperties is not None:
    useViewAction = siteProperties.getProperty('typesUseViewActionInListings', [])

# SIMPLE CONFIGURATION
MAX_TITLE = 255
MAX_DESCRIPTION = 255

# read the extra arguments for the search from the widget.
# This might be a callable function
extra_args = {}
if not object:
  object = getattr(context, objectId)

field = object.getField(fieldName)
widget = field.widget
if hasattr(widget, 'extra_search_args'):
  extra_args = widget.extra_search_args
  if hasattr(object, extra_args):
    extra_args = getattr(object, extra_args)
    if callable(extra_args):
      extra_args = extra_args()

# generate a result set for the query
catalog = context.portal_catalog

field = context.getField(fieldName)

def quotestring(s):
    return '"%s"' % s

def quote_bad_chars(s):
    bad_chars = ["(", ")"]
    for char in bad_chars:
        s = s.replace(char, quotestring(char))
    return s

# for now we just do a full search to prove a point, this is not the
# way to do this in the future, we'd use a in-memory probability based
# result set.
# convert queries to zctextindex
r=q.split(' ')
r = " AND ".join(r)
r = quote_bad_chars(r)+'*'


args = {"SearchableText" : r,
        "portal_type" : allowed_type
       }

args.update(extra_args)

results = catalog(**args)

RESPONSE = context.REQUEST.RESPONSE
RESPONSE.setHeader('Content-Type', 'text/xml;charset=%s' % context.plone_utils.getSiteEncoding())

_ = context.translate
#legend_livesearch = _('legend_livesearch', default='LiveSearch &darr;')
label_no_results_found = _('label_no_results_found', default='No matching results found.')

if not results:
    print '''<fieldset class="livesearchWidgetContainer">'''
    #print '''<legend id="livesearchWidgetLegend">%s</legend>''' % legend_livesearch
    print '''<div class="LSWidgetIEFix">'''
    print '''<div id="LSWidgetNothingFound">%s</div>''' % label_no_results_found
    #print '''<li class="LSWidgetRow">'''
    #print '<a href="search_form" style="font-weight:normal">Advanced Search&hellip;</a>'
    #print '''</li>'''
    print '''</div>'''
    print '''</fieldset>'''

else:
    print '''<fieldset class="livesearchWidgetContainer">'''
    #print '''<legend id="livesearchWidgetLegend">%s</legend>''' % legend_livesearch
    print '''<div class="LSWidgetIEFix">'''
    print '''<ul class="LSWidgetTable">'''
    for result in results[:limit]:
        object = result.getObject()

        print '''<li class="LSWidgetRow">''',
        print '''<img src="%s"/>''' % result.getIcon,
        full_title = pretty_title_or_id(result)
        if len(full_title) >= MAX_TITLE:
            display_title = ''.join((full_title[:MAX_TITLE],'...'))
        else:
            display_title = full_title
        print '''<a href=" #" title="%s" onclick="referencebrowser_setReference('%s', '%s', '%s', '%s'); return false;">%s</a>''' % (full_title, fieldName, object.UID(), display_title, multi, display_title)
        print '''<span class="discreet">[%s%%]</span>''' % result.data_record_normalized_score_
        display_description = result.Description
        if len(display_description) >= MAX_DESCRIPTION:
            display_description = ''.join((display_description[:MAX_DESCRIPTION],'...'))
        print '''<div class="discreet" style="margin-left: 2.5em;">%s</div>''' % (display_description)
        print '''</li>'''
        full_title, display_title, display_description = None, None, None

    print '''</ul>'''
    if len(results)>limit:
        # add a too many found row
        print 'Found too many results&hellip;'
    print '''</div>'''
    print '''</fieldset>'''

return printed
